      SUBROUTINE convmas (pbaru, pbarv, convm )
      IMPLICIT NONE

c=======================================================================
c
c   Auteur:  P. Le Van
c   -------
c
c   Objet:
c   ------
c
c   ********************************************************************
c   .... calcul de la convergence du flux de masse aux niveaux sigma ...
c   ********************************************************************
c
c
c     pbaru  et  pbarv  sont des arguments d'entree pour le s-pg  ....
c      .....  convm      est  un argument de sortie pour le s-pg  ....
c
c    le calcul se fait de haut en bas, les niveaux sigma etant orientes
c    de bas en haut,  c.a.d    sigma(1)     = 1.  au sol
c                              sigma(llm+1) = 0.  au sommet
c    la convergence de masse au niveau sigma(llm+1) est egale a 0. et
c    n'est pas stockee dans le tableau convm .
c
c
c                *********************************************
c
c=======================================================================
c-----------------------------------------------------------------------
c   Declarations:
c   -------------

#include "dimensions.h"
#include "paramet.h"
#include "comvert.h"
#include "logic.h"

      REAL pbaru( ip1jmp1,llm ),pbarv( ip1jm,llm ),convm(  ip1jmp1,llm )
      INTEGER   l,ij

      EXTERNAL   filtreg
      EXTERNAL   convflu

c-----------------------------------------------------------------------
c   calcul de - (d(pbaru)/dx + d(pbarv)/dy ) * dsig(l)   ......

      CALL  convflu( pbaru, pbarv, llm, convm )

      DO 5  l = 1,llm
      DO 5 ij = 1,ip1jmp1
      convm( ij,l ) = convm( ij,l ) * dsig(l)
   5  CONTINUE

c-----------------------------------------------------------------------
c   filtrage:
c   ---------

       CALL filtreg( convm, jjp1, llm, 2,2, .true., 1 )

c    integration de la convergence de masse de haut  en bas ......

      DO 7  l = llmm1, 1, -1
      DO 6 ij = 1,ip1jmp1
      convm(ij,l) = convm(ij,l) + convm(ij,l+1)
   6  CONTINUE
   7  CONTINUE
      RETURN
      END
