      SUBROUTINE SUPHY(KULOUT)
      IMPLICIT LOGICAL(L)
C
C**** *SUPHY*   - INITIALIZE COMMON YOMPHY CONTROLLING PHYSICS
C
C     PURPOSE.
C     --------
C           INITIALIZE YOMPHY, THE COMMON THAT CONTROLS THE
C           PHYSICS OF THE MODEL.
C
C**   INTERFACE.
C     ----------
C        *CALL* *SUPHY(KULOUT)
C
C        EXPLICIT ARGUMENTS :
C        --------------------
C        KULOUT : LOGICAL UNIT FOR THE OUTPUT
C
C        IMPLICIT ARGUMENTS :
C        --------------------
C        COMMON YOMPHY
C
C     METHOD.
C     -------
C        SEE DOCUMENTATION
C
C     EXTERNALS.
C     ----------
C        *SURAD*
C
C     REFERENCE.
C     ----------
C        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE
C     "IN CORE MODEL"
C
C     AUTHOR.
C     -------
C        MATS HAMRUD AND PHILIPPE COURTIER  *ECMWF*
C
C     MODIFICATIONS.
C     --------------
C        ORIGINAL : 87-10-15
C     ------------------------------------------------------------------
#include "yomlun.h"
#include "yomphy.h"
C     -----------------------------------------------------------------
C     NAMELIST/NAMPHY/LVDIF,LRADI
C     -----------------------------------------------------------------
C      ----------------------------------------------------------------
C
C*       1.    SET DEFAULT VALUES.
C              -------------------
C
 100  CONTINUE
      LRADI=.FALSE.
      LVDIF=.FALSE.
      LGWDG=.FALSE.
      LMSFX=.FALSE.
      LSTRA=.FALSE.
      LSCVN=.FALSE.
      LCOND=.FALSE.
      LQNEG=.FALSE.
      LSURF=.FALSE.
      LXXXX=.FALSE.
C      ----------------------------------------------------------------
C
C*       2.    MODIFY DEFAULT VALUES.
C              ----------------------
C
 200  CONTINUE
C     REWIND(NULNAM)
C     READ(NULNAM,NAMPHY)
C      ----------------------------------------------------------------
C
C*       3.    PRINT FINAL VALUES.
C              -------------------
C
 300  CONTINUE
      WRITE(UNIT=KULOUT,FMT='('' COMMON YOMPHY '')')
      WRITE(UNIT=KULOUT,FMT='('' LRADI = '',L5
     S     ,'' LVDIF = '',L5
     S     ,'' LGWDG = '',L5
     S     ,'' LMSFX = '',L5
     S     ,'' LSTRA = '',L5
     S     )')
     S LRADI,LVDIF,LGWDG,LMSFX,LSTRA
      WRITE(UNIT=KULOUT,FMT='('' LRADI = '',L5
     S     ,'' LSCVN = '',L5
     S     ,'' LCOND = '',L5
     S     ,'' LQNEG = '',L5
     S     ,'' LSURF = '',L5
     S     ,'' LXXXX = '',L5
     S     )')
     S LSCVN,LCOND,LQNEG,LSURF,LXXXX
C
C      ----------------------------------------------------------------
C
C*       4.    INITIALIZE RADIATION.
C              ---------------------
C
 400  CONTINUE
      IF (LRADI) THEN
         CALL SURAD(KULOUT)
      END IF
C     -----------------------------------------------------------------
C
      RETURN
      END
