      PROGRAM SULWTAB
C
c     INCLUDE 'dimensions.h'
c     INCLUDE 'dimphys.h'
c     INCLUDE 'dimradmars.h'
      INTEGER  NINT,NTRA,NUA
      INTEGER npademx,nabsmx,nt_pademx

      PARAMETER (NINT=3,NTRA=5,NUA=7)
      PARAMETER (npademx=4,nabsmx=2,nt_pademx=19)

      INTEGER ja,jplk,it
      REAL tmin,tsup

c-----------------------------------------------------------------------
C
C**** *SULW*   - INITIALIZE COMMON YOMLW
C
C     PURPOSE.
C     --------
C           INITIALIZE YOMLW, THE COMMON THAT CONTAINS COEFFICIENTS
C           NEEDED TO RUN THE LONGWAVE RADIATION ROUTINES
C
C**   INTERFACE.
C     ----------
C        *CALL* *SULW
C
C        EXPLICIT ARGUMENTS :
C        --------------------
C        NONE
C
C        IMPLICIT ARGUMENTS :
C        --------------------
C        COMMON YOMLW
C
C     METHOD.
C     -------
C        SEE DOCUMENTATION
C
C     EXTERNALS.
C     ----------
C
C     REFERENCE.
C     ----------
C        ECMWF RESEARCH DEPARTMENT DOCUMENTATION OF THE
C     "IN CORE MODEL"
C
C     AUTHOR.
C     -------
C        JEAN-JACQUES MORCRETTE  *ECMWF*
C
C     MODIFICATIONS.
C     --------------
C        ORIGINAL : 88-12-15
C     ------------------------------------------------------------------
#include "yomlw.h"
C      ----------------------------------------------------------------
C
C*       1.    SET VALUES.
C              -----------
C
      INTEGER puis(3,2,2)
      DATA puis/-4,-1,-1,-4,-1,0,
     s          -1,+1,+1,-1,+1,+1/

      NG1=2
      NG1P1=NG1+1
      NNINT=NINT
      NIPD=2
      NIPD2=2*NIPD
      NTR=11
      NNTRA=NTRA
      NNUA=NUA
      npade=npademx
      nt_pade=nt_pademx
      nabs=nabsmx
      dt_pade=10.
      tmin_pade=125.
C
C
C-- REFERENCE PRESSION FOR THE TRANSMISSION
C
C
C-- REFERENCE TEMPERATURES FOR THE PLANCK FUNCTIONS ----- TSTAND
C          TEMPERATURE DEPENDENCE OF THE ABSORPTION ----- TREF
c     DATA TSTAND,TREF / 200.0, 200.0 /
C
C-- ROOTS AND WEIGHTS FOR THE 2-POINT GAUSSIAN QUADRATURE
c     DATA (RT1(IG1),IG1=1,2) / -0.577350269, +0.577350269 /
c     DATA (WG1(IG1),IG1=1,2) /  1.0        ,  1.0         /

c-----------------------------------------------------------------------
C-- COEFFICIENTS OF THE POLYNOMIALS GIVING THE PLANCK FUNCTIONS
C
c     DATA xp/

c    s  0.64089400E+01, 0.31086273E+02, 0.44921630E+02,
c    s  0.53053980E+01,-0.18466395E+02, 0.90066700E+01,

c    s  0.26110642E+02, 0.12323672E+03, 0.17812691E+03,
c    s  0.33177656E+02,-0.64879380E+02, 0.22575550E+02,

c    s  0.58200418E+02, 0.20855701E+03, 0.32127146E+03,
c    s  0.32439695E+03, 0.17406577E+03,-0.31582220E+02/

c-----------------------------------------------------------------------
c   temperature dependency of absorber amounts:
c   -------------------------------------------

      DATA at
     s / 0.694E-03, 0.272E-02, 0.275E-02, 0.178E-01/
      DATA bt
     s / 0.328E-05, 0.298E-05,-0.705E-04,-0.163E-04/

c-----------------------------------------------------------------------
C-- COEFFICIENTS OF THE POLYNOMIALS GIVING THE TEMPERATURE DEPENDENCE OF
C     THE ABSORPTION
C
c
cinterval 1
      DATA (ga(ie, 1, 1, 1),ie=1,4)
     s / 0.278355E-04, 0.164959E-01,-0.329261E-01, 0.000000E+00/
      DATA (gb(ie, 1, 1, 1),ie=1,4)
     s / 0.278355E-04, 0.140436E-01, 0.525423E+00, 0.100000E+01/

      DATA (ga(ie, 1, 1, 2),ie=1,4)
     s / 0.280173E-04, 0.166060E-01,-0.331191E-01, 0.000000E+00/
      DATA (gb(ie, 1, 1, 2),ie=1,4)
     s / 0.280173E-04, 0.141373E-01, 0.529005E+00, 0.100000E+01/

      DATA (ga(ie, 1, 1, 3),ie=1,4)
     s / 0.281289E-04, 0.166740E-01,-0.332372E-01, 0.000000E+00/
      DATA (gb(ie, 1, 1, 3),ie=1,4)
     s / 0.281289E-04, 0.141950E-01, 0.531254E+00, 0.100000E+01/

      DATA (ga(ie, 1, 1, 4),ie=1,4)
     s / 0.282457E-04, 0.167437E-01,-0.333606E-01, 0.000000E+00/
      DATA (gb(ie, 1, 1, 4),ie=1,4)
     s / 0.282457E-04, 0.142545E-01, 0.533494E+00, 0.100000E+01/

      DATA (ga(ie, 1, 1, 5),ie=1,4)
     s / 0.283684E-04, 0.168159E-01,-0.334902E-01, 0.000000E+00/
      DATA (gb(ie, 1, 1, 5),ie=1,4)
     s / 0.283684E-04, 0.143163E-01, 0.535762E+00, 0.100000E+01/

      DATA (ga(ie, 1, 1, 6),ie=1,4)
     s / 0.284905E-04, 0.168872E-01,-0.336193E-01, 0.000000E+00/
      DATA (gb(ie, 1, 1, 6),ie=1,4)
     s / 0.284905E-04, 0.143774E-01, 0.537967E+00, 0.100000E+01/

      DATA (ga(ie, 1, 1, 7),ie=1,4)
     s / 0.286079E-04, 0.169553E-01,-0.337435E-01, 0.000000E+00/
      DATA (gb(ie, 1, 1, 7),ie=1,4)
     s / 0.286079E-04, 0.144359E-01, 0.540052E+00, 0.100000E+01/

      DATA (ga(ie, 1, 1, 8),ie=1,4)
     s / 0.287189E-04, 0.170194E-01,-0.338610E-01, 0.000000E+00/
      DATA (gb(ie, 1, 1, 8),ie=1,4)
     s / 0.287189E-04, 0.144910E-01, 0.542000E+00, 0.100000E+01/

      DATA (ga(ie, 1, 1, 9),ie=1,4)
     s / 0.288231E-04, 0.170794E-01,-0.339714E-01, 0.000000E+00/
      DATA (gb(ie, 1, 1, 9),ie=1,4)
     s / 0.288231E-04, 0.145426E-01, 0.543812E+00, 0.100000E+01/

      DATA (ga(ie, 1, 1,10),ie=1,4)
     s / 0.289207E-04, 0.171354E-01,-0.340749E-01, 0.000000E+00/
      DATA (gb(ie, 1, 1,10),ie=1,4)
     s / 0.289207E-04, 0.145910E-01, 0.545497E+00, 0.100000E+01/

      DATA (ga(ie, 1, 1,11),ie=1,4)
     s / 0.290123E-04, 0.171879E-01,-0.341720E-01, 0.000000E+00/
      DATA (gb(ie, 1, 1,11),ie=1,4)
     s / 0.290123E-04, 0.146362E-01, 0.547067E+00, 0.100000E+01/

      DATA (ga(ie, 1, 1,12),ie=1,4)
     s / 0.290984E-04, 0.172372E-01,-0.342634E-01, 0.000000E+00/
      DATA (gb(ie, 1, 1,12),ie=1,4)
     s / 0.290984E-04, 0.146787E-01, 0.548535E+00, 0.100000E+01/

      DATA (ga(ie, 1, 1,13),ie=1,4)
     s / 0.291796E-04, 0.172835E-01,-0.343495E-01, 0.000000E+00/
      DATA (gb(ie, 1, 1,13),ie=1,4)
     s / 0.291796E-04, 0.147187E-01, 0.549910E+00, 0.100000E+01/

      DATA (ga(ie, 1, 1,14),ie=1,4)
     s / 0.292561E-04, 0.173272E-01,-0.344307E-01, 0.000000E+00/
      DATA (gb(ie, 1, 1,14),ie=1,4)
     s / 0.292561E-04, 0.147564E-01, 0.551202E+00, 0.100000E+01/

      DATA (ga(ie, 1, 1,15),ie=1,4)
     s / 0.293283E-04, 0.173683E-01,-0.345075E-01, 0.000000E+00/
      DATA (gb(ie, 1, 1,15),ie=1,4)
     s / 0.293283E-04, 0.147920E-01, 0.552416E+00, 0.100000E+01/

      DATA (ga(ie, 1, 1,16),ie=1,4)
     s / 0.293965E-04, 0.174071E-01,-0.345799E-01, 0.000000E+00/
      DATA (gb(ie, 1, 1,16),ie=1,4)
     s / 0.293965E-04, 0.148255E-01, 0.553558E+00, 0.100000E+01/

      DATA (ga(ie, 1, 1,17),ie=1,4)
     s / 0.294606E-04, 0.174436E-01,-0.346481E-01, 0.000000E+00/
      DATA (gb(ie, 1, 1,17),ie=1,4)
     s / 0.294606E-04, 0.148570E-01, 0.554630E+00, 0.100000E+01/

      DATA (ga(ie, 1, 1,18),ie=1,4)
     s / 0.295209E-04, 0.174778E-01,-0.347121E-01, 0.000000E+00/
      DATA (gb(ie, 1, 1,18),ie=1,4)
     s / 0.295209E-04, 0.148866E-01, 0.555634E+00, 0.100000E+01/

      DATA (ga(ie, 1, 1,19),ie=1,4)
     s / 0.295771E-04, 0.175098E-01,-0.347719E-01, 0.000000E+00/
      DATA (gb(ie, 1, 1,19),ie=1,4)
     s / 0.295771E-04, 0.149142E-01, 0.556569E+00, 0.100000E+01/

      DATA (ga(ie, 1, 2, 1),ie=1,4)
     s / 0.280566E-04, 0.166337E-01,-0.331615E-01, 0.000000E+00/
      DATA (gb(ie, 1, 2, 1),ie=1,4)
     s / 0.280566E-04, 0.141601E-01, 0.530085E+00, 0.100000E+01/

      DATA (ga(ie, 1, 2, 2),ie=1,4)
     s / 0.282097E-04, 0.167246E-01,-0.333227E-01, 0.000000E+00/
      DATA (gb(ie, 1, 2, 2),ie=1,4)
     s / 0.282097E-04, 0.142376E-01, 0.532997E+00, 0.100000E+01/

      DATA (ga(ie, 1, 2, 3),ie=1,4)
     s / 0.283806E-04, 0.168248E-01,-0.335030E-01, 0.000000E+00/
      DATA (gb(ie, 1, 2, 3),ie=1,4)
     s / 0.283806E-04, 0.143235E-01, 0.536136E+00, 0.100000E+01/

      DATA (ga(ie, 1, 2, 4),ie=1,4)
     s / 0.285475E-04, 0.169219E-01,-0.336794E-01, 0.000000E+00/
      DATA (gb(ie, 1, 2, 4),ie=1,4)
     s / 0.285475E-04, 0.144067E-01, 0.539123E+00, 0.100000E+01/

      DATA (ga(ie, 1, 2, 5),ie=1,4)
     s / 0.287052E-04, 0.170129E-01,-0.338462E-01, 0.000000E+00/
      DATA (gb(ie, 1, 2, 5),ie=1,4)
     s / 0.287052E-04, 0.144851E-01, 0.541893E+00, 0.100000E+01/

      DATA (ga(ie, 1, 2, 6),ie=1,4)
     s / 0.288529E-04, 0.170979E-01,-0.340028E-01, 0.000000E+00/
      DATA (gb(ie, 1, 2, 6),ie=1,4)
     s / 0.288529E-04, 0.145583E-01, 0.544452E+00, 0.100000E+01/

      DATA (ga(ie, 1, 2, 7),ie=1,4)
     s / 0.289912E-04, 0.171771E-01,-0.341494E-01, 0.000000E+00/
      DATA (gb(ie, 1, 2, 7),ie=1,4)
     s / 0.289912E-04, 0.146266E-01, 0.546821E+00, 0.100000E+01/

      DATA (ga(ie, 1, 2, 8),ie=1,4)
     s / 0.291206E-04, 0.172510E-01,-0.342866E-01, 0.000000E+00/
      DATA (gb(ie, 1, 2, 8),ie=1,4)
     s / 0.291206E-04, 0.146904E-01, 0.549018E+00, 0.100000E+01/

      DATA (ga(ie, 1, 2, 9),ie=1,4)
     s / 0.292415E-04, 0.173200E-01,-0.344150E-01, 0.000000E+00/
      DATA (gb(ie, 1, 2, 9),ie=1,4)
     s / 0.292415E-04, 0.147499E-01, 0.551058E+00, 0.100000E+01/

      DATA (ga(ie, 1, 2,10),ie=1,4)
     s / 0.293546E-04, 0.173843E-01,-0.345351E-01, 0.000000E+00/
      DATA (gb(ie, 1, 2,10),ie=1,4)
     s / 0.293546E-04, 0.148055E-01, 0.552954E+00, 0.100000E+01/

      DATA (ga(ie, 1, 2,11),ie=1,4)
     s / 0.294601E-04, 0.174443E-01,-0.346472E-01, 0.000000E+00/
      DATA (gb(ie, 1, 2,11),ie=1,4)
     s / 0.294601E-04, 0.148574E-01, 0.554715E+00, 0.100000E+01/

      DATA (ga(ie, 1, 2,12),ie=1,4)
     s / 0.295585E-04, 0.175001E-01,-0.347518E-01, 0.000000E+00/
      DATA (gb(ie, 1, 2,12),ie=1,4)
     s / 0.295585E-04, 0.149057E-01, 0.556350E+00, 0.100000E+01/

      DATA (ga(ie, 1, 2,13),ie=1,4)
     s / 0.296500E-04, 0.175520E-01,-0.348491E-01, 0.000000E+00/
      DATA (gb(ie, 1, 2,13),ie=1,4)
     s / 0.296500E-04, 0.149505E-01, 0.557864E+00, 0.100000E+01/

      DATA (ga(ie, 1, 2,14),ie=1,4)
     s / 0.297350E-04, 0.176001E-01,-0.349395E-01, 0.000000E+00/
      DATA (gb(ie, 1, 2,14),ie=1,4)
     s / 0.297350E-04, 0.149922E-01, 0.559266E+00, 0.100000E+01/

      DATA (ga(ie, 1, 2,15),ie=1,4)
     s / 0.298138E-04, 0.176447E-01,-0.350234E-01, 0.000000E+00/
      DATA (gb(ie, 1, 2,15),ie=1,4)
     s / 0.298138E-04, 0.150308E-01, 0.560562E+00, 0.100000E+01/

      DATA (ga(ie, 1, 2,16),ie=1,4)
     s / 0.298869E-04, 0.176861E-01,-0.351013E-01, 0.000000E+00/
      DATA (gb(ie, 1, 2,16),ie=1,4)
     s / 0.298869E-04, 0.150666E-01, 0.561761E+00, 0.100000E+01/

      DATA (ga(ie, 1, 2,17),ie=1,4)
     s / 0.299549E-04, 0.177245E-01,-0.351736E-01, 0.000000E+00/
      DATA (gb(ie, 1, 2,17),ie=1,4)
     s / 0.299549E-04, 0.150999E-01, 0.562873E+00, 0.100000E+01/

      DATA (ga(ie, 1, 2,18),ie=1,4)
     s / 0.300184E-04, 0.177603E-01,-0.352412E-01, 0.000000E+00/
      DATA (gb(ie, 1, 2,18),ie=1,4)
     s / 0.300184E-04, 0.151309E-01, 0.563910E+00, 0.100000E+01/

      DATA (ga(ie, 1, 2,19),ie=1,4)
     s / 0.300781E-04, 0.177941E-01,-0.353049E-01, 0.000000E+00/
      DATA (gb(ie, 1, 2,19),ie=1,4)
     s / 0.300781E-04, 0.151602E-01, 0.564885E+00, 0.100000E+01/

      DATA (ga(ie, 2, 1, 1),ie=1,4)
     s / 0.345270E-01, 0.224888E+01, 0.463477E+01, 0.000000E+00/
      DATA (gb(ie, 2, 1, 1),ie=1,4)
     s / 0.345270E-01, 0.223719E+01, 0.682978E+01, 0.100000E+01/

      DATA (ga(ie, 2, 1, 2),ie=1,4)
     s / 0.329361E-01, 0.214299E+01, 0.439620E+01, 0.000000E+00/
      DATA (gb(ie, 2, 1, 2),ie=1,4)
     s / 0.329361E-01, 0.213139E+01, 0.657806E+01, 0.100000E+01/

      DATA (ga(ie, 2, 1, 3),ie=1,4)
     s / 0.317652E-01, 0.206364E+01, 0.421747E+01, 0.000000E+00/
      DATA (gb(ie, 2, 1, 3),ie=1,4)
     s / 0.317652E-01, 0.205213E+01, 0.638583E+01, 0.100000E+01/

      DATA (ga(ie, 2, 1, 4),ie=1,4)
     s / 0.308749E-01, 0.200626E+01, 0.408637E+01, 0.000000E+00/
      DATA (gb(ie, 2, 1, 4),ie=1,4)
     s / 0.308749E-01, 0.199480E+01, 0.624566E+01, 0.100000E+01/

      DATA (ga(ie, 2, 1, 5),ie=1,4)
     s / 0.302088E-01, 0.196625E+01, 0.399303E+01, 0.000000E+00/
      DATA (gb(ie, 2, 1, 5),ie=1,4)
     s / 0.302088E-01, 0.195482E+01, 0.614767E+01, 0.100000E+01/

      DATA (ga(ie, 2, 1, 6),ie=1,4)
     s / 0.297183E-01, 0.193928E+01, 0.392826E+01, 0.000000E+00/
      DATA (gb(ie, 2, 1, 6),ie=1,4)
     s / 0.297183E-01, 0.192786E+01, 0.608177E+01, 0.100000E+01/

      DATA (ga(ie, 2, 1, 7),ie=1,4)
     s / 0.293620E-01, 0.192189E+01, 0.388469E+01, 0.000000E+00/
      DATA (gb(ie, 2, 1, 7),ie=1,4)
     s / 0.293620E-01, 0.191045E+01, 0.603967E+01, 0.100000E+01/

      DATA (ga(ie, 2, 1, 8),ie=1,4)
     s / 0.291074E-01, 0.191152E+01, 0.385680E+01, 0.000000E+00/
      DATA (gb(ie, 2, 1, 8),ie=1,4)
     s / 0.291074E-01, 0.190006E+01, 0.601513E+01, 0.100000E+01/

      DATA (ga(ie, 2, 1, 9),ie=1,4)
     s / 0.289299E-01, 0.190634E+01, 0.384061E+01, 0.000000E+00/
      DATA (gb(ie, 2, 1, 9),ie=1,4)
     s / 0.289299E-01, 0.189485E+01, 0.600363E+01, 0.100000E+01/

      DATA (ga(ie, 2, 1,10),ie=1,4)
     s / 0.288113E-01, 0.190504E+01, 0.383322E+01, 0.000000E+00/
      DATA (gb(ie, 2, 1,10),ie=1,4)
     s / 0.288113E-01, 0.189351E+01, 0.600189E+01, 0.100000E+01/

      DATA (ga(ie, 2, 1,11),ie=1,4)
     s / 0.287379E-01, 0.190665E+01, 0.383252E+01, 0.000000E+00/
      DATA (gb(ie, 2, 1,11),ie=1,4)
     s / 0.287379E-01, 0.189508E+01, 0.600750E+01, 0.100000E+01/

      DATA (ga(ie, 2, 1,12),ie=1,4)
     s / 0.286996E-01, 0.191048E+01, 0.383694E+01, 0.000000E+00/
      DATA (gb(ie, 2, 1,12),ie=1,4)
     s / 0.286996E-01, 0.189886E+01, 0.601870E+01, 0.100000E+01/

      DATA (ga(ie, 2, 1,13),ie=1,4)
     s / 0.286884E-01, 0.191598E+01, 0.384530E+01, 0.000000E+00/
      DATA (gb(ie, 2, 1,13),ie=1,4)
     s / 0.286884E-01, 0.190432E+01, 0.603411E+01, 0.100000E+01/

      DATA (ga(ie, 2, 1,14),ie=1,4)
     s / 0.286983E-01, 0.192274E+01, 0.385665E+01, 0.000000E+00/
      DATA (gb(ie, 2, 1,14),ie=1,4)
     s / 0.286983E-01, 0.191103E+01, 0.605268E+01, 0.100000E+01/

      DATA (ga(ie, 2, 1,15),ie=1,4)
     s / 0.287244E-01, 0.193043E+01, 0.387026E+01, 0.000000E+00/
      DATA (gb(ie, 2, 1,15),ie=1,4)
     s / 0.287244E-01, 0.191867E+01, 0.607356E+01, 0.100000E+01/

      DATA (ga(ie, 2, 1,16),ie=1,4)
     s / 0.287629E-01, 0.193876E+01, 0.388551E+01, 0.000000E+00/
      DATA (gb(ie, 2, 1,16),ie=1,4)
     s / 0.287629E-01, 0.192696E+01, 0.609604E+01, 0.100000E+01/

      DATA (ga(ie, 2, 1,17),ie=1,4)
     s / 0.288104E-01, 0.194751E+01, 0.390186E+01, 0.000000E+00/
      DATA (gb(ie, 2, 1,17),ie=1,4)
     s / 0.288104E-01, 0.193566E+01, 0.611949E+01, 0.100000E+01/

      DATA (ga(ie, 2, 1,18),ie=1,4)
     s / 0.288641E-01, 0.195645E+01, 0.391884E+01, 0.000000E+00/
      DATA (gb(ie, 2, 1,18),ie=1,4)
     s / 0.288641E-01, 0.194456E+01, 0.614339E+01, 0.100000E+01/

      DATA (ga(ie, 2, 1,19),ie=1,4)
     s / 0.289215E-01, 0.196539E+01, 0.393603E+01, 0.000000E+00/
      DATA (gb(ie, 2, 1,19),ie=1,4)
     s / 0.289215E-01, 0.195346E+01, 0.616723E+01, 0.100000E+01/

      DATA (ga(ie, 2, 2, 1),ie=1,4)
     s / 0.315461E-01, 0.204154E+01, 0.417134E+01, 0.000000E+00/
      DATA (gb(ie, 2, 2, 1),ie=1,4)
     s / 0.315461E-01, 0.203010E+01, 0.632845E+01, 0.100000E+01/

      DATA (ga(ie, 2, 2, 2),ie=1,4)
     s / 0.304413E-01, 0.197136E+01, 0.401057E+01, 0.000000E+00/
      DATA (gb(ie, 2, 2, 2),ie=1,4)
     s / 0.304413E-01, 0.195999E+01, 0.615670E+01, 0.100000E+01/

      DATA (ga(ie, 2, 2, 3),ie=1,4)
     s / 0.295810E-01, 0.192066E+01, 0.389180E+01, 0.000000E+00/
      DATA (gb(ie, 2, 2, 3),ie=1,4)
     s / 0.295810E-01, 0.190932E+01, 0.603223E+01, 0.100000E+01/

      DATA (ga(ie, 2, 2, 4),ie=1,4)
     s / 0.290035E-01, 0.189058E+01, 0.381829E+01, 0.000000E+00/
      DATA (gb(ie, 2, 2, 4),ie=1,4)
     s / 0.290035E-01, 0.187923E+01, 0.595874E+01, 0.100000E+01/

      DATA (ga(ie, 2, 2, 5),ie=1,4)
     s / 0.286421E-01, 0.187574E+01, 0.377854E+01, 0.000000E+00/
      DATA (gb(ie, 2, 2, 5),ie=1,4)
     s / 0.286421E-01, 0.186436E+01, 0.592347E+01, 0.100000E+01/

      DATA (ga(ie, 2, 2, 6),ie=1,4)
     s / 0.284332E-01, 0.187142E+01, 0.376225E+01, 0.000000E+00/
      DATA (gb(ie, 2, 2, 6),ie=1,4)
     s / 0.284332E-01, 0.185999E+01, 0.591477E+01, 0.100000E+01/

      DATA (ga(ie, 2, 2, 7),ie=1,4)
     s / 0.283304E-01, 0.187427E+01, 0.376212E+01, 0.000000E+00/
      DATA (gb(ie, 2, 2, 7),ie=1,4)
     s / 0.283304E-01, 0.186277E+01, 0.592427E+01, 0.100000E+01/

      DATA (ga(ie, 2, 2, 8),ie=1,4)
     s / 0.283015E-01, 0.188200E+01, 0.377314E+01, 0.000000E+00/
      DATA (gb(ie, 2, 2, 8),ie=1,4)
     s / 0.283015E-01, 0.187043E+01, 0.594618E+01, 0.100000E+01/

      DATA (ga(ie, 2, 2, 9),ie=1,4)
     s / 0.283247E-01, 0.189305E+01, 0.379189E+01, 0.000000E+00/
      DATA (gb(ie, 2, 2, 9),ie=1,4)
     s / 0.283247E-01, 0.188142E+01, 0.597652E+01, 0.100000E+01/

      DATA (ga(ie, 2, 2,10),ie=1,4)
     s / 0.283846E-01, 0.190635E+01, 0.381599E+01, 0.000000E+00/
      DATA (gb(ie, 2, 2,10),ie=1,4)
     s / 0.283846E-01, 0.189464E+01, 0.601251E+01, 0.100000E+01/

      DATA (ga(ie, 2, 2,11),ie=1,4)
     s / 0.284703E-01, 0.192113E+01, 0.384373E+01, 0.000000E+00/
      DATA (gb(ie, 2, 2,11),ie=1,4)
     s / 0.284703E-01, 0.190934E+01, 0.605216E+01, 0.100000E+01/

      DATA (ga(ie, 2, 2,12),ie=1,4)
     s / 0.285741E-01, 0.193682E+01, 0.387387E+01, 0.000000E+00/
      DATA (gb(ie, 2, 2,12),ie=1,4)
     s / 0.285741E-01, 0.192496E+01, 0.609403E+01, 0.100000E+01/

      DATA (ga(ie, 2, 2,13),ie=1,4)
     s / 0.286900E-01, 0.195301E+01, 0.390549E+01, 0.000000E+00/
      DATA (gb(ie, 2, 2,13),ie=1,4)
     s / 0.286900E-01, 0.194108E+01, 0.613705E+01, 0.100000E+01/

      DATA (ga(ie, 2, 2,14),ie=1,4)
     s / 0.288136E-01, 0.196939E+01, 0.393785E+01, 0.000000E+00/
      DATA (gb(ie, 2, 2,14),ie=1,4)
     s / 0.288136E-01, 0.195739E+01, 0.618041E+01, 0.100000E+01/

      DATA (ga(ie, 2, 2,15),ie=1,4)
     s / 0.289414E-01, 0.198571E+01, 0.397040E+01, 0.000000E+00/
      DATA (gb(ie, 2, 2,15),ie=1,4)
     s / 0.289414E-01, 0.197363E+01, 0.622346E+01, 0.100000E+01/

      DATA (ga(ie, 2, 2,16),ie=1,4)
     s / 0.290705E-01, 0.200176E+01, 0.400267E+01, 0.000000E+00/
      DATA (gb(ie, 2, 2,16),ie=1,4)
     s / 0.290705E-01, 0.198962E+01, 0.626571E+01, 0.100000E+01/

      DATA (ga(ie, 2, 2,17),ie=1,4)
     s / 0.291985E-01, 0.201738E+01, 0.403426E+01, 0.000000E+00/
      DATA (gb(ie, 2, 2,17),ie=1,4)
     s / 0.291985E-01, 0.200519E+01, 0.630675E+01, 0.100000E+01/

      DATA (ga(ie, 2, 2,18),ie=1,4)
     s / 0.293230E-01, 0.203245E+01, 0.406486E+01, 0.000000E+00/
      DATA (gb(ie, 2, 2,18),ie=1,4)
     s / 0.293230E-01, 0.202020E+01, 0.634625E+01, 0.100000E+01/

      DATA (ga(ie, 2, 2,19),ie=1,4)
     s / 0.294419E-01, 0.204684E+01, 0.409416E+01, 0.000000E+00/
      DATA (gb(ie, 2, 2,19),ie=1,4)
     s / 0.294419E-01, 0.203453E+01, 0.638394E+01, 0.100000E+01/

      DATA cst_voigt / 0.500E-02, 0.100E-01, 0.150E-01, 0.100E+00/

      DO ja=1,2
         PRINT*,'indice centre bord',ja,'\\\\'
         PRINT*
         PRINT*
         tmin=115.
         PRINT*,'\\flushleft'
         PRINT*,'\\begin{tabular}
     s    {|c||c|c|c|c|c|c|c|c|c|c|}\\hline'
         WRITE(6,9990) (-puis(ie,1,ja),ie=1,3)
         WRITE(6,9991) (-puis(ie,2,ja),ie=2,3)
	 WRITE(6,9993)
         DO it=1,19
            tsup=tmin_pade+(it-1)*dt_pade
            PRINT9999,INT(.5*(tsup+tmin)+.1),
     s      (ga(ie,ja,1,it)*10**(-FLOAT(puis(ie,1,ja))),
     s      ga(ie,ja,2,it)*10**(-FLOAT(puis(ie,1,ja))),ie=1,3),
     s      (gb(ie,ja,1,it)*10**(-FLOAT(puis(ie,2,ja))),
     s      gb(ie,ja,2,it)*10**(-FLOAT(puis(ie,2,ja))),ie=2,3)
            tmin=tsup
         ENDDO
         PRINT*,'\\end{tabular}\\\\'
         PRINT*
	 WRITE(10,9992) (cst_voigt(ie,ja),ie=1,2),
     s   at(1,ja)/cst_voigt(2,ja),bt(1,ja)/cst_voigt(2,ja),
     s   at(2,ja)*2.,bt(2,ja)*2.
      ENDDO

c9999  FORMAT('$'I3,'K$',
c     s '&'5('$'e10.4e1'}$ & '),'$'e10.4e1'}$\\\\ \\hline')
9999   FORMAT('$'I3,'$',
     s '&'9('$'f7.4'$ & '),'$'f7.4'$\\\\ \\hline')

9990   FORMAT("$T^k(K)$ ",
     s       "& \\multicolumn{2}{c|}{"
     s       "$a_0^k\\times 10^{"i2.1"}$"
     s       "}& \\multicolumn{2}{c|}{"
     s       "$a_1^k\\times 10^{"i2.1"}$"
     s       "}& \\multicolumn{2}{c|}{"
     s       "$a_2^k\\times 10^{"i2.1"}$")
9991   FORMAT(
     s       "}& \\multicolumn{2}{c|}{"
     s       "$b_1^k\\times 10^{"i2.1"}$"
     s       "}& \\multicolumn{2}{c|}{"
     s      "$b_2^k\\times 10^{"i2.1"}$"
     s       "}\\\\ \\hline \\hline ",/)
9993   FORMAT(
     s       5(" & $\\tau_B$ & $\\tau_{dB}$"/),"\\\\ \\hline")
9992  FORMAT(6('& $ 'e12.3' $ '))

C
      END
