      subroutine WRITEFI(ngrid,nsoil,
     s  unit,ldrs,time,nbetat,co2ice,tsurf,tsoil,emis,q2)
      implicit none
c=================================================================
c
c  Ecriture des fichiers de redemarrage sous format DRS 
c
c  L.Fairhead 04/93
c
c  parametres:
c     unit:                      unite logique d'ecriture
c     time:                      pas de temps de la simulation
c     vcov, ucov, h, pext, phis: champs a ecrire
c     nbetat:                    Nbre d'etats qui seront ecrits
c
c=================================================================
#include "dimensions.h"
#include "dimphys.h"
#include "drsdef.h"
#include "description.h"
#include "drscoorfi.h"

      integer ngrid,nsoil
      logical ldrs
      real co2ice(ngrid),tsurf(ngrid),tsoil(ngrid,nsoil),emis(ngrid)
      real q2(ngrid, nlayermx+1)
      real time
      integer nbetat
      integer unit
      integer ierr, setvdim, setname, putdat, putvdim, cluvdb
      integer it1, it2
      real zz

      IF(ldrs) THEN
c  Ecriture/extension de la coordonnee temps
      ierr = cluvdb()
      ierr = setname(descript,'temps','temps simule','jours',' ')
      ierr = putvdim(unit,1,time,it1,it2)
      write(6,*)' WRITEDEM: it1, it2, ',it1 ,it2

C  ecriture des champs

c co2ice
      ierr = cluvdb()
      ierr = setvdim(1,
     .  ' ','hor_coor',' ',' ',hor_coor(1),hor_coor(ngrid))
      ierr = setvdim(2,
     .  ' ','temps',' ',' ',time,time)
      ierr = setname(descript,'co2ice','CO2 ice cover ',
     .  'Pa',' ')
      ierr = putdat(unit,co2ice)

c tsurf
      ierr = cluvdb()
      ierr = setvdim(1,
     .  ' ','hor_coor',' ',' ',hor_coor(1),hor_coor(ngrid))
      ierr = setvdim(2,
     .  ' ','temps',' ',' ',time,time)
      ierr = setname(descript,'tsurf','Surface temperature  ',
     .  'K',' ')
      ierr = putdat(unit,tsurf)

c tsoil
      ierr = cluvdb()
      ierr = setvdim(1,
     .  ' ','hor_coor',' ',' ',hor_coor(1),hor_coor(ngrid))
      ierr = setvdim(2,
     .  ' ','surf_coor',' ',' ',
     .  surf_coor(1),surf_coor(nsoil))
      ierr = setvdim(3,
     .  ' ','temps',' ',' ',time,time)
      ierr = setname(descript,'tsoil','Soil temperature ',
     .  'K',' ')
      ierr = putdat(unit,tsoil)

c emis
      ierr = cluvdb()
      ierr = setvdim(1,
     .  ' ','hor_coor',' ',' ',hor_coor(1),hor_coor(ngrid))
      ierr = setvdim(2,
     .  ' ','temps',' ',' ',time,time)
      ierr = setname(descript,'emis','surface emissivity  ',
     .  ' ',' ')
      ierr = putdat(unit,emis)

c q2
      ierr = cluvdb()
      ierr = setvdim(1,
     .  ' ','hor_coor',' ',' ',hor_coor(1),hor_coor(ngrid))
      ierr = setvdim(2,
     .  ' ','vert2_coor',' ',' ',
     .  vert2_coor(1),vert2_coor(nlayermx+1))
      ierr = setvdim(3,
     .  ' ','temps',' ',' ',time,time)

      ierr = setname(descript,'q2','pbl wind variance',
     .  ' ',' ')
      ierr = putdat(unit,q2)

      ELSE
c        WRITE(unit) time
c!!! WARNING test 1+1=2
         zz=0.
c        WRITE(unit+1,*) 'zz'
c        WRITE(unit+1,'(3e25.15)') zz
c        WRITE(unit+1,*) 'co2ice'
c        WRITE(unit+1,'(3e25.15)') co2ice
c        WRITE(unit+1,*) 'tsurf'
c        WRITE(unit+1,'(3e25.15)') tsurf
c        WRITE(unit+1,*) 'tsoil'
c        WRITE(unit+1,'(3e25.15)') tsoil
c        WRITE(unit+1,*) 'emis'
c        WRITE(unit+1,'(3e25.15)') emis
c        WRITE(unit+1,*) 'q2'
c        WRITE(unit+1,'(3e25.15)') q2
         WRITE(unit) zz
         WRITE(unit) co2ice,tsurf,tsoil,emis,q2
      ENDIF

      return
      end

